library TriCar;

uses
  System.SysUtils, System.Classes;

type TipoVeicolo = class
        Accelerazione : real;
        Velocita      : real;
        Spostamento   : real;
  end;

{$R *.res}

function CarFollowingPesonalizzato(Vo,DistVeiFronte,VelVeiFronte,AccVeiFronte,DecVeiFronte,LunVeiFronte,
          Amax,Dmax,massa,Uf,Qc,pendenza,Precisione,Vmax,Vdes:real):TipoVeicolo;
var Accelerazione,Vn,du,dv,alfa : real;
begin
//coefficiente Alfa
  Alfa          := 12.192;
  Accelerazione := 0;
  Vn            := 0;
  du            := 0;
  //condizione positiva incrementa la velocit
  if (DistVeiFronte>=5*Vo) then
  begin
    //Accelerazione massima del veicolo
    Accelerazione:=Amax; // m/sec^2
    //Spostamento avuto nell'intervallo di precisione du = 0.5*a*t^2 + Vo * dt
    du:=0.5*Accelerazione*Sqr(Precisione)+Vo*Precisione; //metri
    //variazione di velocit
    dv:=Accelerazione*Precisione; // metri/sec
    //Velocit = Velocit + dv * Precisione
    Vn:=Vo+dV; //metri/sec
    //controlla se la Velocit calcolata  congruente con quella desiderata
    if (Vn>=Vdes) then Vn:=Vdes;
    //controlla se la Velocit calcolata  congruente con quella del veicolo
    if (Vn>Vmax) then Vn:=Vmax;
  end
  else
  begin
    //caso di interazione normale col veicolo che segue
    if (DistVeiFronte>=1*Vo) then
    begin
      //Accelerazione
      Accelerazione:=Alfa*(VelVeiFronte-Vo)/DistVeiFronte;
      //controllo accelerazione massima
      if (Accelerazione>Amax) then Accelerazione:=Amax;
      if (Accelerazione<-1*Dmax) then Accelerazione:=-1*Dmax;
      //Spostamento avuto nell'intervallo di precisione du = 0.5*a*t^2 + Vo * dt
      du:=0.5*Accelerazione*Sqr(Precisione)+Vo*Precisione; //metri
      //variazione di velocit
      dv:=Accelerazione*Precisione; // metri/sec
      //Velocit = Velocit + dv * Precisione
      Vn:=Vo+dv; //metri/sec
      //controlla se la Velocit calcolata  congruente con quella desiderata
      if (Vn>=Vdes) then Vn:=Vdes;
      //controlla se la Velocit calcolata  congruente con quella del veicolo
      if (Vn>Vmax) then Vn:=Vmax;
    end;
    //caso di veicoli troppo vicini
    if (DistVeiFronte<1*Vo) then
    begin
      //Accelerazione
      Accelerazione:=AccVeiFronte;
      //controllo accelerazione massima
      if (Accelerazione>Amax) then Accelerazione:=Amax;
      if (Accelerazione<-1*Dmax) then Accelerazione:=-1*Dmax;
      //Spostamento avuto nell'intervallo di precisione du = 0.5*a*t^2 + Vo * dt
      du:=0.5*Accelerazione*Sqr(Precisione)+Vo*Precisione; //metri
      //variazione di velocit
      dv:=Accelerazione*Precisione; // metri/sec
      //Velocit = Velocit + dv * Precisione
      Vn:=Vo+dv; //metri/sec
      //controlla se la Velocit calcolata  congruente con quella desiderata
      if (Vn>=Vdes) then Vn:=Vdes;
      //controlla se la Velocit calcolata  congruente con quella del veicolo
      if (Vn>Vmax) then Vn:=Vmax;
    end;
  end;
  //ritorna le le variabili
  CarFollowingPesonalizzato               := TipoVeicolo.Create;
  CarFollowingPesonalizzato.Accelerazione := Accelerazione;
  CarFollowingPesonalizzato.Velocita      := Vn;
  CarFollowingPesonalizzato.Spostamento   := du;
  CarFollowingPesonalizzato.Free;
end;

exports CarFollowingPesonalizzato;

begin
end.
